/*
  integer_valued_polynomial_progression.c

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <math.h>
#include "prime_util.h"

int usage(FILE *fp, int argc, char *argv[])
{
  (void)argc;
  fprintf(fp, "Usage:\n\t%s [-c coefficient ...] [-k number]\n", basename(argv[0]));
  return fp == stderr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  huge_uint n, k = 10, i;
  huge_uint *c = NULL;
  size_t n_c = 0;

  for (a=1; a<argc; ++a)
    if (strcmp(argv[a], "-h") == 0)
      return usage(stdout, argc, argv);
    else if (strcmp(argv[a], "-c") == 0 && ++a < argc)
      for (; a<argc; ++a) {
	huge_uint n;
	if ((n = atoll(argv[a]))) {}
	else { --a; break; }
	if ((c = c ? realloc(c, sizeof(*c)*(n_c+1)) : malloc(sizeof(*c)*(n_c+1))))
	  c[n_c++] = n;
      }
    else if (strcmp(argv[a], "-k") == 0 && a+1 < argc)
      k = atoll(argv[++a]);
    else
      break;

  for (i=0; i<k; ++i) {
    n = 0;
    for (size_t j=0; j<n_c; j++) {
      huge_uint x;
      x = pow(i, j);
      n += c[j]*x;
    }
    printf("%llu\n", n);
  }  

  return 0;
}
