/*
  next_prime.c

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include "prime_util.h"

int usage(FILE *fp, int argc, char *argv[])
{
  (void)argc;
  fprintf(fp, "Usage:\n\t%s [number ...]\n", basename(argv[0]));
  return fp == stderr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a, fd;
  huge_uint n, u = 1000000000, n_return;
  isprime_bit_table_element_t *isprime_bit_table;

  if (argc < 2) return usage(stderr, argc, argv);
  isprime_bit_table = isprime_bit_table_mmap(u, &n_return, &fd);
  if (!isprime_bit_table) abort();
  primes_bit_continued_eratosthenes_sieve(n_return, isprime_bit_table, u);
  for (a=1; a<argc; ++a) {
    n = atoll(argv[a]);
    if (!(n < max(n_return, u))) abort();
    if (argc > 2) printf("%llu\t", n);
    n = isprime_bit_table_nextprime(u, isprime_bit_table, n);
    printf("%llu\n", n);
  }

  return 0;
}
