/*
  sum_divisors.c

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <math.h>
#include "prime_util.h"

void stdout_sum_divisors(const huge_uint n)
{
  huge_uint d = 1, sqrt_n, s = 0;

  sqrt_n = sqrt(n);
  for (; d<=sqrt_n; ++d)
    if (n%d == 0) {
      s += d;
      if (d != n/d) s += n/d;
    }
  printf("%llu\n", s);
}

int usage(FILE *fp, int argc, char *argv[])
{
  (void)argc;
  fprintf(fp, "Usage:\n\t%s number [...]\n", basename(argv[0]));
  return fp == stderr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  huge_uint n;

  if (argc < 2) return usage(stderr, argc, argv);
  for (a=1; a<argc; ++a) {
    n = atoll(argv[a]);
    if (argc > 2) printf("%llu\t", n);
    stdout_sum_divisors(n);
  }
  
  return 0;
}
