/*
  superabundants.c

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include "prime_util.h"

int usage(FILE *fp, int argc, char *argv[])
{
  (void)argc;
  fprintf(fp, "Usage:\n\t%s [-u upper]\n", basename(argv[0]));
  return fp == stderr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a, fd;
  huge_uint n, u = 1000000, m = 0, s, o = 1, n_return;
  isprime_bit_table_element_t *isprime_bit_table;

  for (a=1; a<argc; ++a)
    if (strcmp(argv[a], "-h") == 0)
      return usage(stderr, argc, argv);
    else if (strcmp(argv[a], "-u") == 0 && a+1 < argc)
      u = atoll(argv[++a]);
    else
      break;
  
  isprime_bit_table = isprime_bit_table_mmap(u, &n_return, &fd);
  if (!isprime_bit_table) abort();
  primes_bit_continued_eratosthenes_sieve(n_return, isprime_bit_table, u);
  for (n = 1; n < 3 && n < u; ++n)
    if ((s=sum_divisors(n))*o > m*n) {
      printf("%llu\n", n);
      m = s;
      o = n;
    }
  for (; n < u; n = isprime_bit_table_nextcomposite(u, isprime_bit_table, n))
    if ((s=sum_divisors(n))*o > m*n) {
      printf("%llu\n", n);
      m = s;
      o = n;
    }

  return 0;
}
